#include <windows.h>
#include <stdio.h>
#include "hscreen.h"
#include "hdib.h"
#include "appmain.h"

WINAPP			WinApp;
HMENU           hMenuInit;
BYTE			Map[256][256];
HIDDEN_SCREEN	*hScreen;
HIDDEN_SCREEN	*lhScreen;
HDC				MainDC;
HDC				lDC;
static HPALETTE Pal;
HDIB			*Dib;
int				Number_Dibs;
int				CurDib;
BOOL			MouseDown;

int DrawMap(int sx, int sy);
int WriteMap(char *file);
int LoadMap(char *file);
void CreateBitmapWindow(HWND Parent);
LRESULT CALLBACK _export BitmapWndProc(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam);
int SetPixel(int x, int y, BYTE Col);

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR cmdString, int cmdShow)
{
	HWND        MainWnd;
	MSG         msg;
	WNDCLASS    WndClass;

	WinApp.hInstance = hInstance;
	WinApp.hPrevInst = hPrevInst;
	WinApp.cmdShow   = cmdShow;

	WndClass.style          = CS_HREDRAW | CS_VREDRAW;
	WndClass.lpfnWndProc    = WndProc;
	WndClass.cbClsExtra     = 0;
	WndClass.cbWndExtra     = 0;
	WndClass.hInstance      = hInstance;
	WndClass.hIcon          = LoadIcon(WinApp.hInstance, IDI_APPLICATION);
	WndClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
	WndClass.hbrBackground  = (HBRUSH)(GetStockObject(DKGRAY_BRUSH));
	WndClass.lpszMenuName   = NULL;
	WndClass.lpszClassName  = "MAINWND";
	RegisterClass(&WndClass);

	hMenuInit = LoadMenu(WinApp.hInstance, "MAINMENU");
	MainWnd   = CreateWindow("MAINWND", "Map Maker",
							 WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU | WS_HSCROLL | WS_VSCROLL,
							 0, 0, 400, 400,
							 NULL, hMenuInit, hInstance, NULL);
	AdjustClientRegion(MainWnd, 0, 0, 320, 320);
	ShowWindow(MainWnd, cmdShow);
	UpdateWindow(MainWnd);

	for (;;)
	{
		if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
		{
			if(msg.message == WM_QUIT)
				break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
//			if(AppIdle(MainWnd))
				WaitMessage();
		}
	}
	return 0;
};

LRESULT CALLBACK _export WndProc(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam)
{
	int i, j;
	int x, y;
	PAINTSTRUCT ps;
		
	switch(message)
	{
		case WM_CREATE:
			SetScrollRange(hWindow, SB_HORZ, 0, 245, TRUE);
			SetScrollRange(hWindow, SB_VERT, 0, 245, TRUE);
			for(i = 0; i < 256; i++)
				for(j = 0; j < 256; j++)
					Map[i][j] = 0;
			MainDC = GetDC(hWindow);
			SetSystemPaletteUse(MainDC, SYSPAL_NOSTATIC);
			SetSystemPaletteUse(MainDC, SYSPAL_STATIC);
			hScreen = new HIDDEN_SCREEN(MainDC, 320, 320);
			Number_Dibs = 10;
			Dib = new HDIB[Number_Dibs];
			Dib[0].Load("sq1.bmp");
			Dib[1].Load("sq2.bmp");
			Dib[2].Load("sq3.bmp");
			Dib[3].Load("sq4.bmp");
			Dib[4].Load("sq5.bmp");
			Dib[5].Load("sq6.bmp");
			Dib[6].Load("sq7.bmp");
			Dib[7].Load("sq8.bmp");
			Dib[8].Load("sq9.bmp");
			Dib[9].Load("sq10.bmp");
			Pal = Dib[0].ReturnPalette();
			SelectPalette(MainDC, Pal, FALSE);
			RealizePalette(MainDC);
			hScreen->UseDCPal(MainDC);
			DrawMap(GetScrollPos(hWindow, SB_HORZ), GetScrollPos(hWindow, SB_VERT));
			CreateBitmapWindow(hWindow);
			return 0;
		case WM_PAINT:
			BeginPaint(hWindow, &ps);
			x = GetScrollPos(hWindow, SB_HORZ);
			y = GetScrollPos(hWindow, SB_VERT);
			DrawMap(x, y);
			EndPaint(hWindow, &ps);
			return 0;
//		case WM_RBUTTONDOWN:
//			for(y = 0; y < 480; y++)
//				for(x = 0; x < 640; x++)
//					SetPixel(x, y, y & 0xff);
//			hScreen->BltToScreen(MainDC, 0, 0);
//			return 0;
		case WM_HSCROLL:
			switch(LOWORD(wParam))
			{
				case SB_LINELEFT:
					SetScrollPos(hWindow, SB_HORZ, GetScrollPos(hWindow, SB_HORZ) - 1, TRUE);
					break;
				case SB_LINERIGHT:
					SetScrollPos(hWindow, SB_HORZ, GetScrollPos(hWindow, SB_HORZ) + 1, TRUE);
					break;
				case SB_PAGELEFT:
					SetScrollPos(hWindow, SB_HORZ, GetScrollPos(hWindow, SB_HORZ) - 10, TRUE);
					break;
				case SB_PAGERIGHT:
					SetScrollPos(hWindow, SB_HORZ, GetScrollPos(hWindow, SB_HORZ) + 10, TRUE);
					break;
			}
			DrawMap(GetScrollPos(hWindow, SB_HORZ), GetScrollPos(hWindow, SB_VERT));
			return 0;
		case WM_VSCROLL:
			switch(LOWORD(wParam))
			{
				case SB_LINEUP:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) - 1, TRUE);
					break;
				case SB_LINEDOWN:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) + 1, TRUE);
					break;
				case SB_PAGEUP:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) - 10, TRUE);
					break;
				case SB_PAGEDOWN:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) + 10, TRUE);
					break;
			}
			DrawMap(GetScrollPos(hWindow, SB_HORZ), GetScrollPos(hWindow, SB_VERT));
			return 0;
		case WM_LBUTTONDOWN:
			MouseDown = TRUE;
			x = GetScrollPos(hWindow, SB_HORZ);
			y = GetScrollPos(hWindow, SB_VERT);
			i = x + (LOWORD(lParam) >> 5);
			j = y + (HIWORD(lParam) >> 5);
			if(i < 0) i = 0;
			if(i > 255) i = 255;
			if(j < 0) j = 0;
			if(j > 255) j = 255;
			Map[i][j] = CurDib;
			DrawMap(x, y);
			SetCapture(hWindow);
			return 0;
		case WM_MOUSEMOVE:
			if(MouseDown)
			{
				x = GetScrollPos(hWindow, SB_HORZ);
				y = GetScrollPos(hWindow, SB_VERT);
				i = x + (LOWORD(lParam) >> 5);
				j = y + (HIWORD(lParam) >> 5);
				if(i < 0) i = 0;
				if(i > 255) i = 255;
				if(j < 0) j = 0;
				if(j > 255) j = 255;
				Map[i][j] = CurDib;
				DrawMap(x, y);
			}
			return 0;
		case WM_LBUTTONUP:
			MouseDown = FALSE;
			ReleaseCapture();
			return 0;
		case WM_COMMAND:
			switch(wParam)
			{
				case 101:
					SendMessage(hWindow, WM_DESTROY, 0, 0L);
					return 0;
				case 102:
					WriteMap("save.map");
					return 0;
				case 103:
					LoadMap("load.map");
					return 0;
			}
			return(DefWindowProc(hWindow, message, wParam, lParam));
		case WM_DESTROY:
			for(i = 0; i < 10; i++)
				Dib[i].Free();
			delete Dib;
			delete hScreen;
			ReleaseDC(hWindow, MainDC);
			PostQuitMessage(0);
			return 0;
		default:
			return(DefWindowProc(hWindow, message, wParam, lParam));
	}
};

int DrawMap(int sx, int sy)
{
	int x, y;

	for(x = sx; x < sx + 10; x++)
		for(y = sy; y < sy + 10; y++)
			hScreen->DisplayBitmap(Dib[Map[x][y]], ((x - sx) << 5), ((y - sy) << 5));
	hScreen->BltToScreen(MainDC, 0, 0);
	return 0;
};

int WriteMap(char *file)
{
	int x, y;
	FILE *fp;

	fp = fopen(file, "wb");
	for(y = 0; y < 256; y++)
		for(x = 0; x < 256; x++)
		{
			fputc(Map[x][y] + 1, fp);
		}
	fclose(fp);
	return 0;
};

int LoadMap(char *file)
{
	int x, y;
	FILE *fp;

	fp = fopen(file, "rb");
	for(y = 0; y < 256; y++)
		for(x = 0; x < 256; x++)
			Map[x][y] = fgetc(fp) - 1;
	fclose(fp);
	return 0;
};

void CreateBitmapWindow(HWND Parent)
{
	WNDCLASS    WndClass;
	HWND		Wnd;

	WndClass.style          = CS_HREDRAW | CS_VREDRAW;
	WndClass.lpfnWndProc    = BitmapWndProc;
	WndClass.cbClsExtra     = 0;
	WndClass.cbWndExtra     = 0;
	WndClass.hInstance      = WinApp.hInstance;
	WndClass.hIcon          = LoadIcon(WinApp.hInstance, IDI_APPLICATION);
	WndClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
	WndClass.hbrBackground  = (HBRUSH)(GetStockObject(GRAY_BRUSH));
	WndClass.lpszMenuName   = NULL;
	WndClass.lpszClassName  = "BITMAPWND";
	RegisterClass(&WndClass);

	Wnd = CreateWindow("BITMAPWND", "Bitmap",
		WS_OVERLAPPED | WS_VSCROLL,
		0, 0, 64, 64,
		NULL, (HMENU)NULL, WinApp.hInstance, NULL);
	AdjustClientRegion(Wnd, 0, 0, 128, 128);
	SetWindowPos(Wnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);
	UpdateWindow(Wnd);
};

LRESULT CALLBACK _export BitmapWndProc(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
		
	switch(message)
	{
		case WM_CREATE:
			SetScrollRange(hWindow, SB_VERT, 0, Number_Dibs, TRUE);
			lDC = GetDC(hWindow);
			SelectPalette(lDC, Pal, FALSE);
			RealizePalette(lDC);
			lhScreen = new HIDDEN_SCREEN(lDC, 32, 32);
			lhScreen->UseDCPal(lDC);
			return 0;
		case WM_PAINT:
			BeginPaint(hWindow, &ps);
				lhScreen->TDisplayBitmap(Dib[CurDib], 0, 0, 0);
				lhScreen->StretchToScreen(lDC, 0, 0, 128, 128);
			EndPaint(hWindow, &ps);
			return 0;
		case WM_VSCROLL:
			switch(LOWORD(wParam))
			{
				case SB_LINEUP:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) - 1, TRUE);
					CurDib--;
					if(CurDib < 0)
						CurDib = 0;
					break;
				case SB_LINEDOWN:
					SetScrollPos(hWindow, SB_VERT, GetScrollPos(hWindow, SB_VERT) + 1, TRUE);
					CurDib++;
					if(CurDib >= Number_Dibs)
						CurDib = Number_Dibs - 1;
					break;
			}
			lhScreen->DisplayBitmap(Dib[CurDib], 0, 0);
			lhScreen->StretchToScreen(lDC, 0, 0, 128, 128);
			return 0;
		case WM_COMMAND:
			return(DefWindowProc(hWindow, message, wParam, lParam));
		case WM_DESTROY:
			delete lhScreen;
			ReleaseDC(hWindow, lDC);
			return 0;
		default:
			return(DefWindowProc(hWindow, message, wParam, lParam));
	}
};

int SetPixel(int x, int y, BYTE Col)
{
	char *c;

	c = (char *)hScreen->Surface;

	c += y * 320 + x;
	*c = Col;
	return 0;
};
