//ks_mars.cpp by Keith Sibson.
//Executable compiled with BCC 4.5

#include <stdio.h>
#include <alloc.h>
#include <mem.h>
#include <conio.h>
#include <dos.h>
#include <math.h>
#include <stdlib.h>

#pragma inline

char far* bm;
char far* r_vga=(char far*)MK_FP(0xA000,0);	//the vga
char far* vga  =(char far*)farmalloc(0xFFFF);	//This is actualy a vscr

unsigned vgaseg=FP_SEG(r_vga);
unsigned vscrseg=FP_SEG(vga);

typedef unsigned char uc;

main(int argc,char** argv)
{
 int i;

 if(argc!=3) {
	puts("specify 256x256 bmp & pal\n");
	return(0); }

 bm=(char far*)farmalloc(0xFFFF);

 if(!bm || !vga) return(0);

 FILE* input=fopen(argv[1],"rb");

 if(!input) return(0);

 fread(&i,sizeof(int),1,input);
 if(i!=256) return(0);
 fread(&i,sizeof(int),1,input);
 if(i!=256) return(0);

 fread(bm,1,0xFFFF,input);

 fclose(input);

 unsigned ss[200];	//Sky scales
 unsigned si[200];	//Sky incs
 unsigned ytable[300];

 for(i=0;i<200;i++) {
	ss[i]=1280/(i+1);
	float tmp=31.0/(float)(i+1);
	si[i]=tmp*128.0; }

 for(i=0;i<200;i++) ytable[i+100]=320*i;

 for(i=0;i<100;i++) ytable[i]=0;

 unsigned* ytab=ytable+100;

 input=fopen(argv[2],"rb");
 if(!input) return(0);

 asm mov ax,13h
 asm int 10h

 for(i=0;i<256;i++) {
	char rgb[3];
	fread(rgb,1,3,input);
	disable();
	outp(0x3c8,(uc)i);
	outp(0x3c9,rgb[0]);
	outp(0x3c9,rgb[1]);
	outp(0x3c9,rgb[2]);
	enable(); }

 fclose(input);

 uc yp=0;
 uc xp=0;

 char dx=1;

 _fmemset(vga,0,0xFFFF);

 vga+=33;	//Center the screen

 randomize();

 unsigned lastbuf[256];			    //last height at that j
 memset(lastbuf,0xFFFF,256);		    //ensure no draw on first pass

 while(!kbhit()) {

	int j;

	if ((char)rand()>>1==0) dx=(dx==1)?-1:1;	//random movement

	for(i=30;i<200;i++) {	//horizon @ 30

		unsigned acc=0; //scanline index acumulator

		unsigned bmpos=((ss[i]+yp)<<8)+xp;

		for(j=128;j<256;j++) {

			unsigned char c=(char)bm[(acc>>8)+bmpos];

			unsigned tmp=ytab[i-(c>>2)];

			unsigned vgaoffs=(unsigned)j+tmp;

			do {
				vga[vgaoffs]=c;
				vgaoffs-=320;
				lastbuf[j]+=320; } while(lastbuf[j]<tmp);

			lastbuf[j]=tmp;

			acc+=si[i]; }

		acc=0;

		for(j=127;j>=0;j--) {
			unsigned char c=bm[bmpos-(acc>>8)];

			unsigned tmp=ytab[i-(c>>2)];

			unsigned vgaoffs=(unsigned)j+tmp;

			do {
				vga[vgaoffs]=c;
				vgaoffs-=320;
				lastbuf[j]+=320; } while(lastbuf[j]<tmp);

			lastbuf[j]=tmp;

			acc+=si[i]; }
		}

	yp++;
	xp+=dx;

	//flip

	asm cld

	asm mov di,0
	asm mov si,0
	asm mov es,[vgaseg]
	asm push ds
	asm mov ds,[vscrseg]
	asm mov cx,7FFFh
	asm rep movsw

	//clear

	asm mov ax,ds
	asm mov es,ax
	asm mov di,4+320*30
	asm mov ax,0
	asm mov cx,7FFFh-(320*15+2)
	asm rep stosw

	asm pop ds

	for(i=0;i<30;i++) _fmemset(vga+ytab[i],i<<2,256); //sky
	}

 getch();

 asm mov ax,3
 asm int 10h

 farfree(bm);

 return(0);
}
