#ifndef SVGA_HH
	#define SVGA_HH

class SVGA
{
	public:
		SVGA(void);
		~SVGA(void);
		unsigned char SetResolution(char theMode);
		void ClearScreen(unsigned char theColor);
		void PutPixel(short int x, short int y, unsigned char color);
		unsigned char GetPixel(short int x, short int y);
		short int GetWidth(void);
		short int GetHeight(void);
	private:
		void SetPage(short int thePage);
		short int width; //Screen's x size
		short int height; //Screen's y size
		short int nrOfPages; //Number of pages required to fill up the screen
		int lastPage; //This will be zero if width*height/65536 is even.
		unsigned char activePage; //Contains the number of the active bank
                unsigned char *screenBase; //Pointer to video memory
		int *rowY; //Will hold offset values for all rows in Y

                //These new values must be calculated because of eventual
                //bank switching. 
                int *offsetY; //Holds the new y-offsets depending on what page to use
                int *offsetX; //Holds the new x-offsets depending on what page to use
};

#endif
